function sup07800DataDeEmbarqueOperadorLogisticoController(ScreenService, templateManager, ZhFilterPreferences, ZHPromise, General, restEngine, MessageService) {
    
    //Armazena a OL selecionada através do campo Operador Logistico 
	var var_CDFILIOPELOG;
	var var_OL;
	var var_NMFILIAL;
	var var_new_CDFILIOPELOG;
	
    //Abre o filtro
	this.openFilter = function(widget) {
    	ScreenService.showLoader();
        var rowsToSet = {};
		ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
			ScreenService.hideLoader();
		}).catch(error => {
			ScreenService.hideLoader();
		});
    };
    
	//Abre a tela para adicionar um novo OPL
	this.addOPL = function(widget){
	    widget.newRow();
	    widget.getField("OL").readOnly = true;
	    widget.currentRow.OL = var_OL;
	    widget.currentRow.NMFILIAL = var_NMFILIAL;
	    widget.currentRow.CDFILIOPELOG = var_new_CDFILIOPELOG;
	    widget.getField("CDFILIAL").reload();
	};
    
    //Salva a edição do Numero de dias
    this.saveInLineEdit = function(widget, dataSet, name){
        //Salva os registros modificados 
        restEngine.post("opl_solicitacao#/crud/"+name+"/save", {
            "requestType": "DataSet",
            "dataset": dataSet
        }).then(sucesso => {
                widget.activate();
                widget.list();
                widget.reload();
                ScreenService.successNotification("Alteração salva com sucesso.");
            }, error => {
                ScreenService.successNotification("Erro ao salvar alteração.");
            }
		);
	};
	
	//Salva um novo OPL
	this.saveCrud = function(args) {
	    //Refereencia ao widget
	    var widget = args.owner.widget;
        //Armazena o template 
        var template = templateManager.container.getWidget('gridDatadeembarqueOperadorlogísticoWidget');
        //Adiciona o CDFILIOPELOG na array "dataSet"
        args.row.CDFILIOPELOG = var_new_CDFILIOPELOG;
        //Se os campos do formulário forem preenchidos
        if(args.row.CDFILIOPELOG !== '' && args.row.CDFILIAL && args.row.NMPRODUTO !== '' && args.row.IDSOMENTEUTIL !== '' && args.row.NRDIAEMBARQUE !== '' 
        ){
            //Armazena os dados
            let arrayPromisses = [];
            let arrayFiliaisFails = [];
            let arrayFiliaisSuccess = [];
            let arrayFiliais = widget.currentRow.CDFILIAL;
    		ScreenService.showLoader();
            //Passa por cada filial
            arrayFiliais.forEach(filial => {
                //Armazena os dados a serem salvos
                let dataSet = {"data" : 
                    {
                        "CDARVPROD" : args.row.CDARVPROD,
                        "CDFILIOPELOG" : args.row.CDFILIOPELOG,
                        "CDPRODUTO" : args.row.CDPRODUTO,
                        "NRDIAEMBARQUE" : args.row.NRDIAEMBARQUE,
                        "IDSOMENTEUTIL" : args.row.IDSOMENTEUTIL,
                        "__is_new": true
                    }
                };
                //Adiciona a filial na array
                dataSet.data.CDFILIAL = filial;
                //Salva o registro
                arrayPromisses.push(
                    restEngine.post("opl_solicitacao#/crud/dataembarqueol/save", {
                        "requestType": "Row",
                        "row": dataSet.data
                    }).then( function (data) {
                        arrayFiliaisSuccess.push(filial);
                    }, function(error){
                        arrayFiliaisFails.push(filial);
                    })
                );
            });
            //Se o foreach terminou
            ZHPromise.all(arrayPromisses).then(function(){
                //Ordena as arrays em ordem crescente
                arrayFiliaisFails = arrayFiliaisFails.sort((a, b) => a - b);
                //Concatena os itens da array
                let filialFail = arrayFiliaisFails.join();
                //Mensagem para exibir os dados com sucesso ou falha na adição        
                let message = "Não foi possível adicionar Data de Embarque para a(s) Unidade(s) abaixo. <br><br>" + filialFail.toString();
                //Se foi selecionada apenas uma unidade e a mesma já existir no DB
                if (arrayFiliaisFails.length === 1 && arrayFiliaisSuccess.length === 0) {
                    //Se o registro já existe
                    ScreenService.errorNotification("O registro já existe.");
                } else if (arrayFiliaisFails.length === arrayPromisses.length) {
                    //Se todos os registros já existem
                    ScreenService.errorNotification("Já existem dados cadastrados com o mesmo produto para todas Unidades selecionadas.");
                } else {
                    //Retorna resposta ao usuário
                    ScreenService.closeSwipe().then(function () {
                        //Retorna mensagem 
                        if(arrayFiliaisFails.length >= 1){
                            ScreenService.showMessage(message);   
                        }
                        template.reload();
                        widget.activate();
                        widget.list();
                        ScreenService.successNotification("Data de Embarque adicionada com sucesso.");
                    });    
                } 
            });
            ScreenService.hideLoader();
        } else {
            //Verifica se o widget é válido
            widget.isValid();
        }
	};

    //Retorna os dados necessários para execução do filtro do campo UNIDADE
    this.getFieldValueFilter = function(fieldName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBeforeApply = templateManager.container.getActiveWidget();
            
            //test about how widget is... (field or filter)
    	    if(filterBeforeApply.label != 'Filtro'){		
    		    filterBeforeApply = filterBeforeApply.lastActiveWidget;
                filterWidget = filterBeforeApply;
                
            }
            if(filterBeforeApply.name == 'zhFilterPreferencesSelectConditions') {
            	filterWidget = filterBeforeApply;
            }
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
            }
            // Insert values
            if(filterWidget) {
                var valueField;
                if(filterBeforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[fieldName];
                else
                    valueField = filterWidget.FILTER_ROW[fieldName];
                return valueField || null;
            }
            else return null;
        }
        else return null;
    };
    
	//Busca o valor da OL Selecionada
    this.getOLSelecionada = function(args) {
        var_CDFILIOPELOG = args.owner.owner.widget.currentRow.CDFILIAL;
    };
    
    //Busca os dados da OL selecionada
    this.getDataOLFiltered = function(args) {
        var widget = args.owner.owner.widget;
        var_OL = widget.currentRow.OL;
        var_NMFILIAL = widget.currentRow.NMFILIAL;  
        var_new_CDFILIOPELOG = widget.currentRow.CDFILIAL;
    };
    
	//Retorna o valor da OL Selecionada para o dataSourceFilter
    this.getOLForFilterUnidade = function() {
        return var_new_CDFILIOPELOG;
    };
    
    //Seta o filtro a trazer os dados para o grid
    this.setDataSourceFilter = function (args) {
        const widget = templateManager.container.getWidget('gridDatadeembarqueOperadorlogísticoWidget');
        const row = args.e.preference.FILTER_ROW;
        widget.dataSourceFilter = [
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": this.concatArrayForParams(row.CDREGIAO, 'T')
                
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": this.concatArrayForParams(row.CDFILIALUN, 'T')
                
            },
            {
                "name": "P_CDPRODINI",
                "operator": "=",
                "value": row.CDARVPRODINI
            },
            {
                "name": "P_CDPRODFIN",
                "operator": "=",
                "value": row.CDARVPRODFIN
            },
            {
                "name": "P_CDFILIOPELOG",
                "operator": "=",
                "value": row.CDFILIAL
            }
        ];
        widget.reload();
    };
    
    //Limpa os campos do filtro ao selecionar o OPERADOR LÓGISTICO
    this.clearFilterFields = function(args) {
        var widget = args.owner.owner.widget;
		ScreenService.showLoader();
		//Se a OL selecionada for diferente da anterior selecionada ou vazio... apaga o formulário
		if (var_CDFILIOPELOG !== widget.currentRow.CDFILIAL) {
    		if (widget.name === 'zhFilterPreferencesSelectConditions') {
    		    setTimeout(() => {
    		        widget.currentRow.REGIAO = "";
    		        widget.currentRow.CDREGIAO = "";
    		        widget.currentRow.NMREGIAO = "";
    		        widget.getField('REGIAO').clearValue();
    	            widget.currentRow.UNIDADE = "";
    		        widget.currentRow.CDFILIALUN = "";
    		        widget.currentRow.NMFILIALUN = "";
    		        widget.getField('UNIDADE').clearValue();
                    widget.currentRow.NMPRODUTOINI = "";
                    widget.currentRow.CDARVPRODINI = "";
                    widget.currentRow.CDPRODINI = "";
                    widget.getField('NMPRODUTOINI').clearValue();
                    widget.currentRow.NMPRODUTOFIN = "";
                    widget.currentRow.CDARVPRODFIN = "";
                    widget.currentRow.CDPRODFIN = "";
                    widget.getField('NMPRODUTOFIN').clearValue();
    		    }, 200);
    		}
		}
		//Busca os dados da OL selecionada
		this.getDataOLFiltered(args);
        ScreenService.hideLoader();
    };
    
    //Limpa o campo UNIDADE ao alterr o campo REGIÃO
    this.clearFieldUnidade = function(args) {
        var widget = args.owner.owner.widget;
        ScreenService.showLoader();
	    setTimeout(() => {
            widget.currentRow.UNIDADE = "";
	        widget.currentRow.CDFILIALUN = "";
	        widget.currentRow.NMFILIALUN = "";
	        widget.getField('UNIDADE').clearValue();
	    }, 200);
        ScreenService.hideLoader();
    };
    
    //Exclui a linhas selecionadas na listagem
	this.deleteCrudCheckedRows = function(widget) {
        var deferred = ZHPromise.defer();
        MessageService.confirmMessageByCode("CONFIRMA_EXCLUSAO_ITENS").then(function(confirmed) {
            widget.removeCheckedRows().then(function () {
                widget.reload();
                widget.unSelectAll();
                deferred.resolve();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
                deferred.reject();
            });
        });
        return deferred.promise;
    };
    
    // Desabilita ou Habilita as actions de acordo com a aplicação do filtro
    this.changeActionsVisible = function(widget) {
        widget.actions.forEach(action => action.isVisible = widget.appliedFilter? true:false);
    };
    
    //Concatenação de parametros
    this.concatArrayForParams = function(arr, defaultValue) {
        return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    };
   
}

 Configuration(function(ContextRegister) {
    ContextRegister.register("sup07800DataDeEmbarqueOperadorLogisticoController", sup07800DataDeEmbarqueOperadorLogisticoController);
});